/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Point_$type, runOn, typeCast, markType, markDep } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { RangeValueList } from "./RangeValueList";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
/**
 * @hidden
 */
export let HorizontalRangeCategorySeries = /*@__PURE__*/ (() => {
    class HorizontalRangeCategorySeries extends RangeCategorySeries {
        fetchXAxis() {
            return this.xAxis;
        }
        fetchYAxis() {
            return this.yAxis;
        }
        nh() {
            super.nh();
            this.xAxis = null;
            this.yAxis = null;
        }
        ah(a) {
            let b = this.aj(this.vn(), this.vo.f, this.wp(this.cg), this.wq(this.cg), this.to(a), true);
            if (b == null) {
                return null;
            }
            let c = b[0];
            let d = b[1];
            let e = new Array(1);
            let f = new Array(2);
            f[0] = { $type: Point_$type, x: c[0], y: c[2] };
            f[1] = { $type: Point_$type, x: d[0], y: d[2] };
            e[0] = f;
            return e;
        }
        ai(a) {
            let b = this.aj(this.vn(), this.vo.f, this.wp(this.cg), this.wq(this.cg), this.to(a), true);
            if (b == null) {
                return null;
            }
            let c = b[0];
            let d = b[1];
            let e = new Array(1);
            let f = new Array(2);
            f[0] = { $type: Point_$type, x: c[0], y: c[1] };
            f[1] = { $type: Point_$type, x: d[0], y: d[1] };
            e[0] = f;
            return e;
        }
        get_e8() {
            return true;
        }
        bu() {
            if (this.bv == 0) {
                return 1;
            }
            else {
                return super.bu();
            }
        }
        getOffsetValue() {
            return this.RangeFramePreparer.r(this.xAxis, this.cg.by, this.cg.bx, this.getEffectiveViewport1(this.cg));
        }
        getCategoryWidth() {
            return this.xAxis.getCategorySize(this.cg.by, this.cg.bx, this.getEffectiveViewport1(this.cg));
        }
        je(a, b) {
            return this.jf(a, b, this.xAxis, runOn(this, this.wn), new RangeValueList(this.highColumn, this.lowColumn));
        }
        jg(a, b) {
            return this.jh(a, b, this.xAxis, runOn(this, this.wn), new RangeValueList(this.highColumn, this.lowColumn));
        }
        hu(a, b, c, d, e) {
            if (c == null) {
                return Number.POSITIVE_INFINITY;
            }
            let f = this.xAxis.lf;
            return this.hv(a, b, this.xAxis, d, e, f, runOn(this, this.wn));
        }
        ia(a, b, c) {
            if (this.cv == null) {
                return NaN;
            }
            let d = this.getEffectiveViewport1(this.cg);
            let e = new ScalerParams(0, this.cv.tr, this.cg.bx, this.xAxis.ch, d);
            let f = this.RangeFramePreparer.r(this.xAxis, this.cv.tr, this.cg.bx, d);
            return this.ic(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, runOn(this, this.wn), b, c);
        }
        h8(a, b, c) {
            if (this.cv == null) {
                return NaN;
            }
            let d = this.getEffectiveViewport1(this.cg);
            let e = new ScalerParams(0, this.cv.tr, this.cg.bx, this.xAxis.ch, d);
            let f = this.RangeFramePreparer.r(this.xAxis, this.cv.tr, this.cg.bx, d);
            return this.ic(this.lowColumn, a, this.xAxis, e, f, runOn(this, this.wn), b, c);
        }
        h6(a, b, c) {
            if (this.cv == null) {
                return NaN;
            }
            let d = this.getEffectiveViewport1(this.cg);
            let e = new ScalerParams(0, this.cv.tr, this.cg.bx, this.xAxis.ch, d);
            let f = this.RangeFramePreparer.r(this.xAxis, this.cv.tr, this.cg.bx, d);
            return this.ic(this.highColumn, a, this.xAxis, e, f, runOn(this, this.wn), b, c);
        }
        tf(a, b, c) {
            return this.tl(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.cg.by, this.cg.bx, this.getEffectiveViewport1(this.cg)), this.yAxis, this.xAxis, runOn(this, this.h6), (d, e) => this.jh(d, e, this.xAxis, runOn(this, this.wn), this.highColumn), (d, e) => this.jf(d, e, this.xAxis, runOn(this, this.wn), this.highColumn));
        }
        th(a, b, c) {
            return this.tl(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.cg.by, this.cg.bx, this.getEffectiveViewport1(this.cg)), this.yAxis, this.xAxis, runOn(this, this.h8), (d, e) => this.jh(d, e, this.xAxis, runOn(this, this.wn), this.lowColumn), (d, e) => this.jf(d, e, this.xAxis, runOn(this, this.wn), this.lowColumn));
        }
        tj(a, b, c) {
            return this.tl(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.cg.by, this.cg.bx, this.getEffectiveViewport1(this.cg)), this.yAxis, this.xAxis, null, null, null);
        }
        wj() {
            return this.yAxis != null && this.yAxis.c1();
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            switch (b) {
                case HorizontalRangeCategorySeries.$$p[4]:
                    this.nq(typeCast(Axis.$, c));
                    this.ph(typeCast(Axis.$, d));
                    this.vx.cu.g(this.hk);
                    this.pr(false);
                    this.om();
                    break;
                case HorizontalRangeCategorySeries.$$p[5]:
                    this.nq(typeCast(Axis.$, c));
                    this.ph(typeCast(Axis.$, d));
                    this.vx.cu.g(this.hk);
                    this.wj();
                    this.pr(false);
                    this.om();
                    break;
            }
        }
        x5(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        x4(a) {
            if (typeCast(CategoryXAxis.$, a) !== null || a.ce) {
                return true;
            }
            return false;
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.h8(c, false, false);
            let e = this.h6(c, false, false);
            let f = new DataLegendSeriesValueInfo();
            f.a = 1;
            f.l = e > d ? d : e;
            f.p = "Low";
            f.q = this.xt != null ? this.xt : "Low";
            f.r = this.ya != null ? this.ya : "L:";
            f.s = this.yc != null ? this.yc : "";
            let g = new DataLegendSeriesValueInfo();
            g.a = 2;
            g.l = e > d ? e : d;
            g.p = "High";
            g.q = this.xq != null ? this.xq : "High";
            g.r = this.x6 != null ? this.x6 : "H:";
            g.s = this.x8 != null ? this.x8 : "";
            let h = new DataLegendSeriesValueInfo();
            h.a = 7;
            h.l = Math.abs(g.l - f.l);
            h.p = "Range";
            h.q = "Range";
            h.r = "R:";
            h.k = true;
            let i = new DataLegendSeriesValueInfo();
            i.a = 6;
            i.l = f.l + (h.l / 2);
            i.p = "Average";
            i.q = "Average";
            i.r = "A:";
            i.k = true;
            let j = new DataLegendSeriesContext();
            j.f = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(g);
                $ret.add(f);
                $ret.add(h);
                $ret.add(i);
                return $ret;
            })());
            j.b = this.aw();
            return j;
        }
        get useHighMarkerFidelity() {
            return this.wk;
        }
    }
    HorizontalRangeCategorySeries.$t = /*@__PURE__*/ markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
    HorizontalRangeCategorySeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['HighMemberAsLegendLabel:x6:yg', [2, null], 'HighMemberAsLegendUnit:x8:yh', [2, null], 'LowMemberAsLegendLabel:ya:yi', [2, null], 'LowMemberAsLegendUnit:yc:yj', [2, null], 'XAxis::yk', [CategoryAxisBase.$, null], 'YAxis::yl', [NumericYAxis.$, null]]);
    return HorizontalRangeCategorySeries;
})();
